import { JSXElement } from "solid-js";
import { Value } from "./create-select";
type Values = Value[];
interface Option {
    label: JSXElement;
    value: Value;
    disabled: boolean;
}
interface CreateOptionsConfig {
    key?: string;
    filterable?: boolean;
    createable?: boolean | ((inputValue: string) => Value);
    disable?: (value: Value) => boolean;
}
declare const createOptions: (values: Values | ((inputValue: string) => Values), userConfig?: CreateOptionsConfig) => {
    options: (inputValue: string) => Option[];
    optionToValue: (option: Option) => any;
    isOptionDisabled: (option: Option) => boolean;
    format: (item: Option | Value, type: "option" | "value") => any;
};
export { createOptions };
